//+------------------------------------------------------------------+
//|                                       Nonlagma_EA_RB_V1.mq4      |
//|                            Rogrio Borges, Copyright 2016        |
//|                                          rogeriob28@gmail.com    | 
//+------------------------------------------------------------------+
#property copyright "Rogerio Borges,Copyright 2016"
#property link      "rogeriob28@gmail.com"
#include <stdlib.mqh>
// You Need Custom Indicator named nonlagma_nrp_1_1.
string STR_OMyPointYPE[]={"Buy","Sell","Buy Limit","Sell Limit","Buy Stop","Sell Stop"};
enum displayLike
{
   dis_lines, // Display as lines
   dis_dots   // Display as dots
};

//--- input parameters
extern string Comentario = "Nonlagma ADX EA V1.3 ";
extern bool   UseAutoMagic     = true;
extern int    ManualMagic      = 5010100;
input int            TakeProfit=10;
input int            StopLoss=20;
input double         LotSize=1;
input int            Slippage=3;

extern string dummy1      = "";      // .
extern string IndicadorNonlagma      = "Indicador Nonlagma";      // Settings for indicators
extern int    BarToUse    = 1;       // Bar to test (0, for still opened, 1 for first closed, and so on)
extern int                Length          = 5;             // Nonlag ma calculation length
extern ENUM_APPLIED_PRICE Price           = PRICE_CLOSE;    // Price to use
extern bool               alertsOn        = false;           // Turn alert on?
extern bool               alertsOnCurrent = false;           // Alerts on current (still opened) bar?
extern bool               alertsMessage   = false;           // Alerts should show pop-up message?
extern bool               alertsSound     = false;          // Alerts should play alert sound?
extern bool               alertsEmail     = false;          // Alerts shoyuld send an email?
extern displayLike        DisplayType     = dis_lines;      // What should the display be like?
extern bool               Interpolate     = false;           // Interpolate in multi time frame mode?
extern string XP="---------------- XPips Settings";
extern int XPipsUnderOver=2;
extern string SAR="---------------- Parabolic SAR Settings";
extern double Step=0.02;
extern double Maximum=0.2;
extern string ADX=" --- ADXm Cross Settings";
extern int PlusDiMinusDi_Period = 20;
extern int Applied_Price        =  0; // 0 Close , 1 Open , 2 High , 3 Low , 4 Median , 5 Typical , 6 Weighted
extern int LineWidth            =  3;


extern string dummy4      = "";      // General settings
extern string    stopheader="== Advanced Stops ==";
extern double    TrailingStop=2;
extern bool      TrailingStopOnlyProfit=true;
extern bool      TrailingStopRegular=false;
extern int       breakEvenAtProfit=0;
extern int       breakEvenShift=0;

extern bool          UsarLockProfit= false;
double Preset_SL   = 10;
double Preset_TP   = 50;
extern int    Target1     = 2;
extern int    LockProft1  = 2;
extern int    Target2     = 3;
extern int    LockProfit2 = 3;
extern int    Target3     = 4;
extern int    LockProfit3 = 4;
extern int    Target4     = 5;
extern int    LockProfit4 = 5;
extern int    Target5     = 6;
extern int    LockProfit5 = 6;
extern int    Target6     = 7;
extern int    LockProfit6 = 7;
extern int    Target7     = 8;
extern int    LockProfit7 = 8;
extern int    Target8     = 9;
extern int    LockProfit8 = 9;
extern int    Target9     = 10;
extern int    LockProfit9 = 10;
extern int    Target10     = 11;
extern int    LockProfit10 = 11;
extern int    Target11     = 12;
extern int    LockProfit11 = 12;
extern int    Target12     = 13;
extern int    LockProfit12 = 13;
extern int    Target13     = 14;
extern int    LockProfit13 = 14;
extern int    Target14     = 15;
extern int    LockProfit14 = 15;
extern int    Target15     = 16;
extern int    LockProfit15 = 16;
extern int    Target16     = 17;
extern int    LockProfit16 = 17;
extern int    Target17     = 20;
extern int    LockProfit17 = 20;
extern int    Target18     = 25;
extern int    LockProfit18 = 25;
extern int    Target19     = 30;
extern int    LockProfit19 = 30;
extern int    Target20     = 35;
extern int    LockProfit20 = 35;

extern bool      DisplayInfo = false;    // Dislay info

bool dummyResult;
double PointRatio = 1;
//--- global variables
double MyPoint;
int    MySlippage;
int digits=MarketInfo(Symbol(),MODE_DIGITS);
int MagicNumber;
//--- indicators
double nonlagma_trend_current;
double nonlagma_trend_previous;
double adx_Up;
double adx_Dn;
double BV=0,SV=0;
double OP1;
double PSAR;
double OP2;
//EA name
string  EANAME="NLGAdxV.1.3";
string  EASHORTNAME="NLGAdxV.1.3";
string Symb;

bool Level_1 = TRUE;
bool Level_2 = FALSE;
bool Level_3 = FALSE;
bool Level_4 = FALSE;
bool Level_5 = FALSE;
bool Level_6 = FALSE;
bool Level_7 = FALSE;
bool Level_8 = FALSE;
bool Level_9 = FALSE;
bool Level_10 = FALSE;
bool Level_11 = FALSE;
bool Level_12 = FALSE;
bool Level_13 = FALSE;
bool Level_14 = FALSE;
bool Level_15 = FALSE;
bool Level_16 = FALSE;
bool Level_17 = FALSE;
bool Level_18 = FALSE;
bool Level_19 = FALSE;
bool Level_20 = FALSE;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()   
{ 
//---------

               
// Unique sting id.    
   string id = WindowExpertName() + Symbol() + Period();
    
  if (UseAutoMagic)
    
   // If there isn't already a Global Variable with the id in wich search for the MagicNumber create it  
   if(!GlobalVariableCheck(id))
   {
      MagicNumber = WindowHandle(Symbol(),0);   
      GlobalVariableSet(id,MagicNumber);
   }
   else // Just get the MagicNumber for the unique id
   {
      MagicNumber = GlobalVariableGet(id);
   }
   else  MagicNumber = ManualMagic;   
  
 
        
   MyPoint = MyPoint();
   MySlippage = MySlippage(); 
  
   
//MyPoint=MarketInfo(OrderSymbol(),MODE_POINT);
//---------
return(0); 
}
int deinit() 
{ 
// ---------
Comment("");

// -----
return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//


void OnTick()
{

   int OrdersOpen=0, buyOrders=0, sellOrders=0, pendingOrders=0;
   Symb=Symbol();   
   
   checkOrderStatus(OrdersOpen,buyOrders,sellOrders,pendingOrders);
   advancedStopManager(OrdersOpen);
   RefreshRates();

   if(TotalOpenOrders() == 0 && IsNewBar() == true)
   { 
      // Initialize Indicators
      InitIndicators();
   
      // Check Buy Entry
      if(BuySignal() == true)
         {
            OpenBuy();
         }
      
      // Check Sell Entry
      else if(SellSignal() == true)
         {
            OpenSell();
         }  
   }      
   Comment("Nolagma_Trend_current= ",nonlagma_trend_current," Nolagma_Previous= ",nonlagma_trend_previous, " PSAR: ", PSAR," OP2: ",OP2,"  ADX Up: ", adx_Up, " Adx DN: ", adx_Dn);
      
   return(0);
} // Fim start

//-------------------------------------------------------------------
void regularTrailingStop() 
{
   int cnt, total = OrdersTotal();
   
   for(cnt=0;cnt<total;cnt++)
     {
      if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
       {

        if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
          {if(TrailingStop>0)  
           {if(OrderType()==OP_BUY)
              {if(OrderStopLoss()<Bid-MyPoint*TrailingStop)
                 { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-MyPoint*TrailingStop,digits),OrderTakeProfit(),0,Green); 
                 }}}
            else
              {if((OrderStopLoss()>(Ask+MyPoint*TrailingStop)) || (OrderStopLoss()==0))
                 { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+MyPoint*TrailingStop,digits),OrderTakeProfit(),0,Red); 
                 }}}}}
}

//+------------------------------------------------------------------+

void onlyProfitTrailingStop() 
   {
   
   int cnt, total = OrdersTotal();

   for(cnt=0;cnt<total;cnt++)
     {
      if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      {

        if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
          {if(TrailingStop>0)  
           {if(OrderType()==OP_BUY)
              {if(Bid-OrderOpenPrice()>MyPoint*TrailingStop)
                 {if(OrderStopLoss()<Bid-MyPoint*TrailingStop)
                    { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-MyPoint*TrailingStop,digits),OrderTakeProfit(),0,Green); 
                        }}}}
            else
              {if((OrderOpenPrice()-Ask)>(MyPoint*TrailingStop))
                 {if((OrderStopLoss()>(Ask+MyPoint*TrailingStop)) || (OrderStopLoss()==0))
                    { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+MyPoint*TrailingStop,digits),OrderTakeProfit(),0,Red); 
                        }}}}}}}
   
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
void breakEvenManager() 

   {
   
   for(int cnt=0;cnt<OrdersTotal();cnt++)
     {
      if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      {

        if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
         {if(breakEvenAtProfit>0)  
           {if(OrderType()==OP_BUY)
              {if(Bid-OrderOpenPrice()>=MyPoint*breakEvenAtProfit)
                 {if(OrderStopLoss()!=OrderOpenPrice() + breakEvenShift*MyPoint)
                    { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+ breakEvenShift*MyPoint,OrderTakeProfit(),0,Green); 
                        }}}}
             else
              {if((OrderOpenPrice()-Ask)>(MyPoint*breakEvenAtProfit))
                 {if(OrderStopLoss()!=OrderOpenPrice() - breakEvenShift*MyPoint)
                    { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()- breakEvenShift*MyPoint,OrderTakeProfit(),0,Red); 
                        }}}}}}}
   
//+------------------------------------------------------------------+
void advancedStopManager(int OrdersOpen) 
{
   if (TrailingStopOnlyProfit && TrailingStopRegular)
      {Print("Both Trailing Stops are enabled.  Defaulted to Regular TS.");}
    
   if (OrdersOpen >= 1)
   {
     if (UsarLockProfit==true) Locking();

      if (breakEvenAtProfit>0)
         breakEvenManager();
      if (TrailingStopRegular)
          regularTrailingStop();
      else if (TrailingStopOnlyProfit)
          onlyProfitTrailingStop();
      
    }
}
//+---------------------------------------------------------------------------+


  
  //+------------------------------------------------------------------+

 
void checkOrderStatus(int& OrdersOpen,int& buyOrders,int& sellOrders,int& pendingOrders)
{
   for(int cnt=OrdersTotal();cnt>=0;cnt--)
     {
      if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      {
        if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber /**/ )
        {  
         if (OrderType()==OP_BUY)
            {buyOrders++; OrdersOpen++;}
         else if (OrderType()==OP_SELL)
            {sellOrders++; OrdersOpen++;}
         else
            {pendingOrders++; OrdersOpen++;}
        }
       }
     }
}

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| GetChartTimeFrame                                                |
//+------------------------------------------------------------------+
string GetChartTimeFrame()
{   
   //ChartTimeFrame
   string TimeFrame ;
   switch(Period())
   {
      case 1:     TimeFrame = "M1";break;
      case 5:     TimeFrame = "M5"; break;
      case 15:    TimeFrame = "M15"; break;
      case 30:    TimeFrame = "M30"; break;
      case 60:    TimeFrame = "H1"; break;
      case 240:   TimeFrame = "H4"; break;
      case 1440:  TimeFrame = "D1";  break;
      case 10080: TimeFrame = "W1"; break;
      case 43200: TimeFrame = "MN1"; break;
   }
   return(TimeFrame);
}

// -------- Lock profit

void Locking()
{
// -----
int total;
if ((LockProft1 > Target1) || (LockProfit2 > Target2) || (LockProfit3 > Target3) || (LockProfit4 > Target4) || (LockProfit5 > Target5) || (LockProfit6 > Target6) || (LockProfit7 > Target7) || (LockProfit8 > Target8) || (LockProfit9 > Target9) || (LockProfit10 > Target10)) Comment("Wrong setting of Target or Stop Loss !");
   if ((Target1 > 0) && (subOrdersTotal() > 0) && Level_1 || Level_2 || Level_3 || Level_4 || Level_5 || Level_6 || Level_7 || Level_8 || Level_9 || Level_10) {
      total = OrdersTotal();
      RefreshRates();
      for (int pos = 0; pos < OrdersTotal(); pos++) {
         dummyResult=OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
         if((OrderStopLoss()==0) && (OrderTakeProfit()==0)) {
            if(OrderType()==OP_BUY) {dummyResult=OrderModify(OrderTicket(), Ask,Ask - Preset_SL * MyPoint, Ask + Preset_TP * MyPoint, 0, CLR_NONE);}
            if(OrderType()==OP_SELL){dummyResult=OrderModify(OrderTicket(), Bid, Bid + Preset_SL * MyPoint, Bid - Preset_TP * MyPoint, 0, CLR_NONE);}     
          }  
         if (OrderType() <= OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber()==MagicNumber) {
            if (OrderType() == OP_BUY) {
               if (Level_1) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target1 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProft1) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProft1, OrderTakeProfit(), 0, Green);
                     if (Target2 > 0) Level_2 = TRUE;
                     return (0);
                  }
               }
               if (Level_2) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target2 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit2) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit2, OrderTakeProfit(), 0, Green);
                     if (Target3 > 0) Level_3 = TRUE;
                     return (0);
                  }
               }
               if (Level_3) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target3 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit3) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit3, OrderTakeProfit(), 0, Green);
                     if (Target4 > 0) Level_4 = TRUE;
                     return (0);
                  }
               }
               if (Level_4) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target4 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit4) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit4, OrderTakeProfit(), 0, Green);
                     if (Target5 > 0) Level_5 = TRUE;
                     return (0);
                  }
               }               
               if (Level_5) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target5 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit5) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit5, OrderTakeProfit(), 0, Green);
                     if (Target6 > 0) Level_6 = TRUE;
                     return (0);
                  }
               }               
               if (Level_6) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target6 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit6) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit6, OrderTakeProfit(), 0, Green);
                     if (Target7 > 0) Level_7 = TRUE;
                     return (0);
                  }
               }                              
               if (Level_7) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target7 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit7) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit7, OrderTakeProfit(), 0, Green);
                     if (Target8 > 0) Level_8 = TRUE;
                     return (0);
                  }
               }               
               if (Level_8) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target8 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit8) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit8, OrderTakeProfit(), 0, Green);
                     if (Target9 > 0) Level_9 = TRUE;
                     return (0);
                  }
               }
               if (Level_9) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target9 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit9) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit9, OrderTakeProfit(), 0, Green);
                     if (Target10 > 0) Level_10 = TRUE;
                     return (0);
                  }
               }  
               if (Level_10) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target10 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit10) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit10, OrderTakeProfit(), 0, Green);
                     if (Target11 > 0) Level_11 = TRUE;
                     return (0);
                  }
               }  
               if (Level_11) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target11 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit11) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit11, OrderTakeProfit(), 0, Green);
                     if (Target12 > 0) Level_12 = TRUE;
                     return (0);
                  }
               }
               if (Level_12) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target12 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit12) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit12, OrderTakeProfit(), 0, Green);
                     if (Target13 > 0) Level_13 = TRUE;
                     return (0);
                  }
               }
               if (Level_13) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target13 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit13) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit13, OrderTakeProfit(), 0, Green);
                     if (Target14 > 0) Level_14 = TRUE;
                     return (0);
                  }
               }  
               if (Level_14) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target14 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit14) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit14, OrderTakeProfit(), 0, Green);
                     if (Target15 > 0) Level_15 = TRUE;
                     return (0);
                  }
               }
               if (Level_15) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target15 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit15) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit15, OrderTakeProfit(), 0, Green);
                     if (Target16 > 0) Level_16 = TRUE;
                     return (0);
                  }
               } 
               if (Level_16) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target16 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit16) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit16, OrderTakeProfit(), 0, Green);
                     if (Target17 > 0) Level_17 = TRUE;
                     return (0);
                  }
               }  
               if (Level_17) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target17 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit17) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit7, OrderTakeProfit(), 0, Green);
                     if (Target18 > 0) Level_18 = TRUE;
                     return (0);
                  }
               }  
               if (Level_18) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target18 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit18) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit18, OrderTakeProfit(), 0, Green);
                     if (Target19 > 0) Level_19 = TRUE;
                     return (0);
                  }
               } 
               if (Level_19) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target19 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit19) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit19, OrderTakeProfit(), 0, Green);
                     if (Target20 > 0) Level_20 = TRUE;
                     return (0);
                  }
               }                                                                                                                                                                                                          
               if (Level_20) {
                  if (Bid - OrderOpenPrice() >= MyPoint * Target20 && OrderStopLoss() < OrderOpenPrice() + MyPoint * LockProfit20) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + MyPoint * LockProfit20, OrderTakeProfit(), 0, Green);
                     return (0);
                  }
               }
            }
            if (OrderType() == OP_SELL) {
               if (Level_1) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target1 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProft1 || OrderStopLoss() == 0.0) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProft1, OrderTakeProfit(), 0, Red);
                     if (Target2 > 0) Level_2 = TRUE;
                     return (0);
                  }
               }
               if (Level_2) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target2 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit2) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit2, OrderTakeProfit(), 0, Red);
                     if (Target3 > 0) Level_3 = TRUE;
                     return (0);
                  }
               }
               if (Level_3) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target3 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit3) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit3, OrderTakeProfit(), 0, Red);
                     if (Target4 > 0) Level_4 = TRUE;
                     return (0);
                  }
               }
               if (Level_4) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target4 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit4) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit4, OrderTakeProfit(), 0, Red);
                     if (Target5 > 0) Level_5 = TRUE;
                     return (0);
                  }
               } 
               if (Level_5) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target5 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit5) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit5, OrderTakeProfit(), 0, Red);
                     if (Target6 > 0) Level_6 = TRUE;
                     return (0);
                  }
               }
               if (Level_6) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target6 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit6) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit6, OrderTakeProfit(), 0, Red);
                     if (Target7 > 0) Level_7 = TRUE;
                     return (0);
                  }
               }
               if (Level_7) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target7 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit7) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit7, OrderTakeProfit(), 0, Red);
                     if (Target8 > 0) Level_8 = TRUE;
                     return (0);
                  }
               }
               if (Level_8) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target8 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit8) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit8, OrderTakeProfit(), 0, Red);
                     if (Target9 > 0) Level_9 = TRUE;
                     return (0);
                  }
               }  
               if (Level_9) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target9 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit9) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit9, OrderTakeProfit(), 0, Red);
                     if (Target10 > 0) Level_10 = TRUE;
                     return (0);
                  }
               }                                     
               if (Level_10) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target10 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit10) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit10, OrderTakeProfit(), 0, Red);
                     if (Target11 > 0) Level_11 = TRUE;
                     return (0);
                  }
               } 
                if (Level_11) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target11 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit11) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit11, OrderTakeProfit(), 0, Red);
                     if (Target12 > 0) Level_12 = TRUE;
                     return (0);
                  }
               } 
                if (Level_12) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target12 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit12) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit12, OrderTakeProfit(), 0, Red);
                     if (Target13 > 0) Level_13 = TRUE;
                     return (0);
                  }
               }
                if (Level_13) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target13 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit13) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit13, OrderTakeProfit(), 0, Red);
                     if (Target14 > 0) Level_14 = TRUE;
                     return (0);
                  }
               } 
                if (Level_14) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target14 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit14) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit14, OrderTakeProfit(), 0, Red);
                     if (Target15 > 0) Level_15 = TRUE;
                     return (0);
                  }
               }
                if (Level_15) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target15 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit15) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit15, OrderTakeProfit(), 0, Red);
                     if (Target16 > 0) Level_16 = TRUE;
                     return (0);
                  }
               } 
                if (Level_16) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target16 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit16) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit16, OrderTakeProfit(), 0, Red);
                     if (Target17 > 0) Level_17 = TRUE;
                     return (0);
                  }
               }
                if (Level_17) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target17 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit17) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit17, OrderTakeProfit(), 0, Red);
                     if (Target18 > 0) Level_18 = TRUE;
                     return (0);
                  }
               } 
                if (Level_18) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target18 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit18) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit18, OrderTakeProfit(), 0, Red);
                     if (Target19 > 0) Level_19 = TRUE;
                     return (0);
                  }
               }
                if (Level_19) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target19 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit19) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit19, OrderTakeProfit(), 0, Red);
                     if (Target20 > 0) Level_20 = TRUE;
                     return (0);
                  }
               }                                                                                                                                   
               if (Level_20) {
                  if (OrderOpenPrice() - Ask >= MyPoint * Target20 && OrderStopLoss() > OrderOpenPrice() - MyPoint * LockProfit20) {
                     dummyResult=OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - MyPoint * LockProfit20, OrderTakeProfit(), 0, Red);
                     return (0);
                  }
               }                             
            }
         }
      }
   }
RefreshRates();
// -------

} // Fim Locking

// ------------------  subOrdersTotal
int subOrdersTotal() {
   int order;
   RefreshRates();
   int order_total = OrdersTotal();
   for (int pos = 0; pos < order_total; pos++) {
      dummyResult=OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() <= OP_SELL && OrderSymbol() == Symbol()) order++;
   }
   return (order);
} // fIM subOrdersTotal
/////

   
// Get My Points   
double MyPoint()
{
   double CalcPoint = 0;
   
   if(_Digits == 2 || _Digits == 3) CalcPoint = 0.01;
   else if(_Digits == 4 || _Digits == 5) CalcPoint = 0.0001;
   
   return(CalcPoint);
}


// Get My Slippage
int MySlippage()
{
   int CalcSlippage = 0;
   
   if(_Digits == 2 || _Digits == 4) CalcSlippage = Slippage;
   else if(_Digits == 3 || _Digits == 5) CalcSlippage = Slippage * 10;
   
   return(CalcSlippage);
}

   
// Check if there is a new bar
bool IsNewBar()   
{        
   static datetime RegBarTime=0;
   datetime ThisBarTime = Time[0];
      
   if (ThisBarTime == RegBarTime)
   {
      return(false);
   }
   else
   {
      RegBarTime = ThisBarTime;
      return(true);
   }
}   

   
// Returns the number of total open orders for this Symbol and MagicNumber
int TotalOpenOrders()
{
   int total_orders = 0;
   
   for(int order = 0; order < OrdersTotal(); order++) 
   {
      if(OrderSelect(order,SELECT_BY_POS,MODE_TRADES)==false) break;
      
      if(OrderMagicNumber() == MagicNumber && OrderSymbol() == _Symbol)
         {
            total_orders++;
         }
   }
   
   return(total_orders);
}

//+------------------------------------------------------------------+
//| Custom functions                                                 |
//+------------------------------------------------------------------+


// Initialize Indicators
void InitIndicators()
{
 
   //Nonlagma
    nonlagma_trend_current  =iCustom(NULL,0,"nonlagma_nrp_1_1",0,Length,Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,false,3,BarToUse);
    nonlagma_trend_previous = iCustom(NULL,0,"nonlagma_nrp_1_1",0,Length,Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,false,3,BarToUse+1);
   //PSAR
    PSAR=iSAR(_Symbol,PERIOD_CURRENT,Step,Maximum,1);
    
    //ADX Cross
    //ixo
      //double diIXO10=iCustom(NULL,0,"I_XO_A_H",PeriodIXO,0,0); //up
      //double diIXO21=iCustom(NULL,0,"I_XO_A_H",PeriodIXO,1,0); //dn
      
      //diIXO10 > d22 // Buy
     // diIXO21< d22 // Sell
    adx_Up=iCustom(NULL,0,"adx-cross-hull-style_1_1",PlusDiMinusDi_Period,Applied_Price,LineWidth,0,BarToUse); 
    adx_Dn=iCustom(NULL,0,"adx-cross-hull-style_1_1",PlusDiMinusDi_Period,Applied_Price,LineWidth,1,BarToUse);
    Comment("Nolagma_Trend_current= ",nonlagma_trend_current," Nolagma_Previous= ",nonlagma_trend_previous, " PSAR: ", PSAR," OP2: ",OP2,"  ADX Up: ", adx_Up, " Adx DN: ", adx_Dn);
}


// Buy Logic
bool BuySignal()
{
   double d22=(0);
   OP2=iOpen(_Symbol,PERIOD_CURRENT,0);
   OP1=iOpen(_Symbol,PERIOD_CURRENT,0);
   BV =0;
   

   if(Bid>=(OP1+XPipsUnderOver*MyPoint))
   //if(High[1] && Low[1] > XPipsUnderOver*MyPoint)
    {
      BV=1;
     }

   if(nonlagma_trend_current==1 && OP2>PSAR && adx_Up!=EMPTY_VALUE) // Buy)
   //if(nonlagma_trend_current==1 && OP2>PSAR && adx_Up>d22 && BV==1)
   {
      return(true);
   }
   else
   {
      return(false);
   }
}


// Sell Logic
bool SellSignal()
{
   double d22=(0);
   OP2=iOpen(_Symbol,PERIOD_CURRENT,0);
   OP1=iOpen(_Symbol,PERIOD_CURRENT,0);
   SV=0;
   if(Ask<=(OP1-XPipsUnderOver*MyPoint))
   //if(High[1] && Low[1] > XPipsUnderOver*MyPoint)
   { 
     SV=1;
   }  
   if(nonlagma_trend_current==-1 && OP2<PSAR && adx_Dn!=EMPTY_VALUE) // Sell
   //if(nonlagma_trend_current==-1 && OP2<PSAR && adx_Dn<d22 && SV==1)
   {
      return(true);
   }
   else
   {
      return(false);
   }
}
 
 
// Open Buy Order
void OpenBuy()
{
  if ((High[1]-Low[1])/(_Point*MathPow(10,MathMod(_Digits,2))) >= XPipsUnderOver)
   {
   // Open Buy Order
   
   int ticket = OrderSend(_Symbol,OP_BUY,LotSize,Ask,MySlippage,0,0,EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_S",MagicNumber);
      
      if(ticket<0)
      {
         Print("OrderSend failed with error #",GetLastError());
      }
      else
      {
         Print("OrderSend placed successfully");
      }
                 
   // Modify Buy Order
   bool res = OrderModify(ticket,OrderOpenPrice(),Ask-StopLoss*MyPoint,Ask+TakeProfit*MyPoint,0);
      
      if(!res)
      {
         Print("Error in OrderModify. Error code=",GetLastError());
      }
      else
      {
         Print("Order modified successfully.");
      }
   }   
}


// Open Sell Order
void OpenSell()
{
 if ((High[1]-Low[1])/(_Point*MathPow(10,MathMod(_Digits,2))) >= XPipsUnderOver)
  {
   //Open Sell Order
   int ticket = OrderSend(_Symbol,OP_SELL,LotSize,Bid,MySlippage,0,0,EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_S",MagicNumber);
      
      if(ticket<0)
      {
         Print("OrderSend failed with error #",GetLastError());
      }
      else
      {
         Print("OrderSend placed successfully");
      }
                 
   // Modify Sell Order
   bool res = OrderModify(ticket,OrderOpenPrice(),Bid+StopLoss*MyPoint,Bid-TakeProfit*MyPoint,0);
      
      if(!res)
      {
         Print("Error in OrderModify. Error code=",GetLastError());
      }
      else
      {
         Print("Order modified successfully.");
      }   
  }     
}